# Visualization Library

A lightweight C++ OpenGL middleware for 2D/3D graphics

[Home] [Tutorials] [All Classes] [Grouped Classes]

# vl::VertexAttributeArray Class Reference

Implements a generic OpenGL Shading Language vertex attribute to be used with a Geometry. More...

`#include <VertexAttributeArray.hpp>`

Inheritance diagram for vl::VertexAttributeArray:

List of all members.

## Public Member Functions

virtual const char * | className ()
| Returns the name of the class.
| VertexAttributeArray (unsigned int location, bool normalize, bool pure_integer, ArrayAbstract *data)
| VertexAttributeArray ()
ArrayAbstract * | data () const
| The GPU buffer that stores the data.
unsigned int | attribIndex () const
| The 'index' parameter of the vertex attribute as used with glVertexAttribPointer() and glEnableVertexAttribArray().
bool | normalize () const
| The 'normalized' parameter as used with glVertexAttribPointer().
bool | pureInteger () const
| If set to true glVertexAttribIPointer() will be used instead of glVertexAttribPointer().
void | setData (ArrayAbstract *data)
| The GPU buffer that stores the data.
void | setAttribIndex (unsigned int index)
| The 'index' parameter of the vertex attribute as used with glVertexAttribPointer() and glEnableVertexAttribArray().
void | setNormalize (bool normalize)
| The 'normalized' parameter as used with glVertexAttribPointer().
void | setPureInteger (bool pure_integer)
| If set to true glVertexAttribIPointer() will be used instead of glVertexAttribPointer().

## Protected Attributes

ref< ArrayAbstract > | mData
unsigned int | mAttribIndex
bool | mNormalize
bool | mPureInteger

## Detailed Description

Implements a generic OpenGL Shading Language vertex attribute to be used with a Geometry.

## Constructor & Destructor Documentation

vl::VertexAttributeArray::VertexAttributeArray | ( | unsigned int | location,
|  | bool | normalize,
|  | bool | pure_integer,
|  | ArrayAbstract * | data |
| ) |  |  | `[inline]`

vl::VertexAttributeArray::VertexAttributeArray | ( |  | ) | `[inline]`

## Member Function Documentation

virtual const char* vl::VertexAttributeArray::className | ( |  | ) | `[inline, virtual]`

Returns the name of the class.

Reimplemented from vl::Object.

ArrayAbstract* vl::VertexAttributeArray::data | ( |  | ) | const`[inline]`

The GPU buffer that stores the data.

unsigned int vl::VertexAttributeArray::attribIndex | ( |  | ) | const`[inline]`

The 'index' parameter of the vertex attribute as used with glVertexAttribPointer() and glEnableVertexAttribArray().

See also:
  - http://www.opengl.org/sdk/docs/man/xhtml/glVertexAttribPointer.xml
  - http://www.opengl.org/sdk/docs/man/xhtml/glEnableVertexAttribArray.xml

bool vl::VertexAttributeArray::normalize | ( |  | ) | const`[inline]`

The 'normalized' parameter as used with glVertexAttribPointer().

See also:
  - http://www.opengl.org/sdk/docs/man/xhtml/glVertexAttribPointer.xml

bool vl::VertexAttributeArray::pureInteger | ( |  | ) | const`[inline]`

If set to true glVertexAttribIPointer() will be used instead of glVertexAttribPointer().

This feature requires GL_EXT_gpu_shader4.

See also:
  - http://developer.download.nvidia.com/opengl/specs/GL_EXT_gpu_shader4.txt

void vl::VertexAttributeArray::setData | ( | ArrayAbstract * | data | ) | `[inline]`

The GPU buffer that stores the data.

void vl::VertexAttributeArray::setAttribIndex | ( | unsigned int | index | ) | `[inline]`

The 'index' parameter of the vertex attribute as used with glVertexAttribPointer() and glEnableVertexAttribArray().

See also:
  - http://www.opengl.org/sdk/docs/man/xhtml/glVertexAttribPointer.xml
  - http://www.opengl.org/sdk/docs/man/xhtml/glEnableVertexAttribArray.xml

void vl::VertexAttributeArray::setNormalize | ( | bool | normalize | ) | `[inline]`

The 'normalized' parameter as used with glVertexAttribPointer().

See also:
  - http://www.opengl.org/sdk/docs/man/xhtml/glVertexAttribPointer.xml

void vl::VertexAttributeArray::setPureInteger | ( | bool | pure_integer | ) | `[inline]`

If set to true glVertexAttribIPointer() will be used instead of glVertexAttribPointer().

This feature requires GL_EXT_gpu_shader4.

See also:
  - http://developer.download.nvidia.com/opengl/specs/GL_EXT_gpu_shader4.txt

## Member Data Documentation

ref<ArrayAbstract> vl::VertexAttributeArray::mData`[protected]`

unsigned int vl::VertexAttributeArray::mAttribIndex`[protected]`

bool vl::VertexAttributeArray::mNormalize`[protected]`

bool vl::VertexAttributeArray::mPureInteger`[protected]`

The documentation for this class was generated from the following file:

- E:/VisualizationLibrary/BuildSystem/VL_DISTRO/Visualization_Library_SDK/src/vl/VertexAttributeArray.hpp

Visualization Library v2009.07 Reference Documentation
Copyright 2005-2009 Michele Bosi. All rights reserved.
Updated on Mon Aug 10 21:41:45 2009.
Permission is granted to use this page to write and publish articles regarding Visualization Library.